#include "Arduino.h"
#include "TW2.h"

TW2::TW2(unsigned char scl, unsigned char sda)
{
  pinMode(scl,OUTPUT);
  pinMode(sda,OUTPUT);
  _scl = scl;
  _sda = sda;
}


unsigned char TW2::read_TW2_Reg(unsigned char adress)
{
  unsigned char i;
  unsigned char value=0;
  unsigned char maske=0x80;
  
  adress |= 0xC0;
  
  digitalWrite(_sda,HIGH);
  for(i=8;i>0;i--)
  {  
    digitalWrite(_scl,HIGH);
    if(adress & maske)
      digitalWrite(_sda,HIGH);
    else
      digitalWrite(_sda,LOW);
    maske>>=1;
    delayMicroseconds(10);    
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);    
  }
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);    
  pinMode(_sda,INPUT);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);    
      
  maske = 0x80;
  for(i=8;i>0;i--)
  {
    digitalWrite(_scl,HIGH);
    delayMicroseconds(10);
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);
    if(digitalRead(_sda))
      value|=maske;
    maske>>=1;
    delayMicroseconds(10);
  }
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);

  pinMode(_sda,OUTPUT);
  return (value);  
}


void TW2::write_TW2_Reg(unsigned char adress, unsigned char data)
{
  unsigned char i;
  unsigned char maske=0x80;
  
  adress |= 0x80;
  
  digitalWrite(_sda,HIGH);
  for(i=8;i>0;i--)
  {  
    digitalWrite(_scl,HIGH);
    if(adress & maske)
      digitalWrite(_sda,HIGH);
    else
      digitalWrite(_sda,LOW);
    maske>>=1;
    delayMicroseconds(10);    
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);    
  }
  maske = 0x80;
  for(i=8;i>0;i--)
  {
    digitalWrite(_scl,HIGH);
    if(data & maske)
      digitalWrite(_sda,HIGH);
    else
      digitalWrite(_sda,LOW);
    maske>>=1;
    delayMicroseconds(10);    
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);
  }
  digitalWrite(_sda,LOW);
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);
}


unsigned int TW2::read_TW2_EEPROM(unsigned int adress)
{
  unsigned char i;
  unsigned int value=0;
  unsigned int maske=0x00000080;

  adress |= 0xE0;

  digitalWrite(_sda,HIGH);
  for(i=8;i>0;i--)
  {  
    digitalWrite(_scl,HIGH);
    if(adress & maske)
      digitalWrite(_sda,HIGH);
    else
      digitalWrite(_sda,LOW);
    maske>>=1;
    delayMicroseconds(10);    
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);    
  }
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);    
  pinMode(_sda,INPUT);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);    
      
  maske = 0x80000000;
  for(i=32;i>0;i--)
  {
    digitalWrite(_scl,HIGH);
    delayMicroseconds(10);
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);
    if(digitalRead(_sda))
      value|=maske;
    maske>>=1;
    delayMicroseconds(10);
  }
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);

  pinMode(_sda,OUTPUT);
  return (value);    
}


void TW2::write_TW2_EEPROM(unsigned int adress, unsigned int data)
{
  unsigned char i;
  unsigned int maske=0x00000080;

  adress |= 0xA0;
  
  digitalWrite(_sda,HIGH);
  for(i=8;i>0;i--)
  {  
    digitalWrite(_scl,HIGH);
    if(adress & maske)
      digitalWrite(_sda,HIGH);
    else
      digitalWrite(_sda,LOW);
    maske>>=1;
    delayMicroseconds(10);    
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);    
  }
  maske = 0x80000000;
  for(i=32;i>0;i--)
  {
    digitalWrite(_scl,HIGH);
    if(data & maske)
      digitalWrite(_sda,HIGH);
    else
      digitalWrite(_sda,LOW);
    maske>>=1;
    delayMicroseconds(10);    
    digitalWrite(_scl,LOW);
    delayMicroseconds(10);
  }
  digitalWrite(_sda,LOW);
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);
  digitalWrite(_scl,HIGH);
  delayMicroseconds(10);
  digitalWrite(_scl,LOW);
  delayMicroseconds(10);
  delayMicroseconds(20);
}